#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "imageInput.h"

#define BUFFER_SIZE 100
#define FILE_HEADER_STRING "__info2_image_file_format__"


/// @brief Gets the next char value from specified and opened file
/// @param openedFile stream FILE, from which to read
/// @param iterations how many chars are being taken from (1 char equals 2 Hexdecimals equals 8bit)
static int getCharValueFromFile(FILE* openedFile, int iterations) {
    int addToFile = 0;

    if (openedFile == NULL) return 0;

    for (int i = 0; i < iterations; i++) {
        int tmp = fgetc(openedFile);
        //If the File ends, the method returns a '0'
        if (openedFile == EOF) return addToFile;

        addToFile += tmp; 
    }

    return addToFile;
}

// TODO Vervollständigen Sie die Funktion readImages unter Benutzung Ihrer Hilfsfunktionen
GrayScaleImageSeries *readImages(const char *path)
{
    GrayScaleImageSeries *series = NULL;

    FILE* openFile;

    openFile = fopen(path, "rb");

    // file Could not be opened/does not exist
    if (openFile != NULL) {

         char* actualFileTag = malloc(strlen(FILE_HEADER_STRING) * sizeof(char));
         int numberOfImages = 0;
         int width = 0;
         int height = 0;

        for (int i = 0; i < strlen(FILE_HEADER_STRING); i++) {
            actualFileTag += fgetc(openFile);
        }

        // checks if the files are equal: strcmp should return '0' --> convert it to '1' for 'true'
        int fileTagEqual = !strcmp(actualFileTag, FILE_HEADER_STRING);

        //we only need the fileTag to verify its an image for our series.
        free(actualFileTag);
        actualFileTag = NULL;


        if (fileTagEqual) {
            numberOfImages = getCharValueFromFile(openFile, 2);

            // no Images in series -> No image-series
            if (numberOfImages == 0) {
                fclose(openFile);
                return series;
            }

            width  = getCharValueFromFile(openFile, 2);
            height = getCharValueFromFile(openFile, 2);

            // no height/width --> impossible file 
            if(height == 0 || width == 0) {
                fclose(openFile);
                return series;
            }

            //all the starting parameters are set --> the images can be read and stored
            GrayScaleImage* images = malloc(numberOfImages * sizeof(GrayScaleImage));
            unsigned char* labels = malloc(numberOfImages * sizeof(unsigned char));

            series->count = 0;
            series->images = images;
            series->labels = labels;

            for (int i = 0; i < numberOfImages; i++) {
                for (int j = 0; j < width * height; j++) {
                    // allocating the actual matrix image for image
                    images[i].buffer = malloc(width * height);

                    images[i].height = height;
                    images[i].width = width;
                    images[i].buffer[j] = fgetc(openFile);
                }
                //rest of the values that only affect the image itself
                series->labels[i] = fgetc(openFile);
                series->count++;
            }
        }
    }

    fclose(openFile);
    return series;
}

// TODO Vervollständigen Sie die Funktion clearSeries, welche eine Bildserie vollständig aus dem Speicher freigibt
void clearSeries(GrayScaleImageSeries *series)
{
    for (int i = 0; i < series->count; i++) {
        free(series->images[i].buffer);
    }

    free(series->images);
    series->images = NULL;
    free(series->labels);
    series->labels = NULL;
}